/**
* LogBox appender providing asynchronous HTTP
*/
component extends="HTTPAppender" {
	
	AsyncHTTPAppender function init(
		required string name,
		struct properties = {},
		string layout = "",
		numeric levelMin = 0,
		numeric levelMax = 4
	){
		super.init( argumentCollection = arguments );
		// strong reference to super scope if not cf9 and below choke on high load and cfthread
		variables.$super = super;
		return this;
	}
	
	/**
	* Pass an entry to HTTP request
	*/
	public void function logMessage( required any logEvent ){
		var uuid = createobject("java", "java.util.UUID").randomUUID();
		var threadName = "#getname()#_logMessage_#replace(uuid,"-","","all")#";

		if( getUtil().inThread() ){
			super.logMessage(arguments.logEvent);
		} else {
			thread name = threadName logEvent = arguments.logEvent {
				variables.$super.logMessage( attributes.logEvent );
			}
		}
	}
}